//
//  BaseUnit.h
//  LordGame
//
//  Created by Michael Dyachenko on 24/01/15.
//  Copyright (c) 2015 AppBit. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <SpriteKit/SpriteKit.h>
#import "Byname.h"

static NSString* const KingKey = @"King";
static NSString* const KnightKey = @"Knight";
static NSString* const MonkKey = @"Monk";
static NSString* const JesterKey = @"Jester";
static NSString* const MageKey = @"Mage";

typedef struct {
    char event;
    char solution;
    char result;
} Statistic;

@interface BaseUnit : NSObject
{
    NSString* _name;
    Byname* _byname;
    SKSpriteNode* _sprite;
    
    NSMutableDictionary* _stats;
}

- (void)changeStatistic:(Statistic)data;
- (void)getNewByname:(NSString*)key;

@property (strong, nonatomic, readonly) SKSpriteNode* sprite;
@property (strong, nonatomic, readonly) NSString* name;
@property (strong, nonatomic, readonly) NSString* byname;//кличка
@property (strong, nonatomic, readonly) NSString* fullName;
@property (strong, nonatomic, readonly) NSString* description;

@end
