//
//  BaseUnit.m
//  LordGame
//
//  Created by Michael Dyachenko on 24/01/15.
//  Copyright (c) 2015 AppBit. All rights reserved.
//

#import "BaseUnit.h"

@implementation BaseUnit

- (void)changeStatistic:(Statistic)data
{
    [self addStatistic:[self statKey:data] value:3];
    
    if (data.event != 0) {
        data.event = 0;
        [self addStatistic:[self statKey:data] value:1];
    }
    else {
        data.event = 1;
        [self addStatistic:[self statKey:data] value:1];
        data.event = -1;
        [self addStatistic:[self statKey:data] value:1];
    }
    
    if (data.solution != 0) {
        data.solution = 0;
        [self addStatistic:[self statKey:data] value:1];
    }
    else {
        data.solution = 1;
        [self addStatistic:[self statKey:data] value:1];
        data.solution = -1;
        [self addStatistic:[self statKey:data] value:1];
    }
    
    if (data.result != 0) {
        data.result = 0;
        [self addStatistic:[self statKey:data] value:1];
    }
    else {
        data.result = 1;
        [self addStatistic:[self statKey:data] value:1];
        data.result = -1;
        [self addStatistic:[self statKey:data] value:1];
    }
    
    [self checkByname];
}

- (void)addStatistic:(NSString*)key value:(int)value
{
    if (_stats == nil) {
        _stats = [NSMutableDictionary new];
    }
    
    NSNumber* oldValue = _stats[key];
    _stats[key] = @(oldValue.intValue + value);
}

- (NSString*)statKey:(Statistic)data
{
    return [NSString stringWithFormat:@"%@%@%@", [self keyPartByAttribute:data.event], [self keyPartByAttribute:data.solution], [self keyPartByAttribute:data.result]];
}
        
- (NSString*)keyPartByAttribute:(char)attribute
{
    if (attribute < 0) {
        return @"-";
    }
    
    if (attribute > 0) {
        return @"+";
    }
    
    return @"0";
}

- (void)checkByname
{
    NSArray* keyList = _stats.allKeys;
    int maxValue = 3;
    NSString* maxKey = nil;
    
    for (NSString* key in keyList) {
        NSNumber* curValue = _stats[key];
        if (curValue.intValue >= maxValue) {
            maxKey = key;
            maxValue = curValue.intValue;
        }
    }
    
    if (maxKey != nil) {
        [_stats removeAllObjects];
        [self getNewByname:maxKey];
    }
}

- (NSString *)name
{
    return _name;
}

- (NSString *)byname
{
    return _byname.title;
}

- (NSString *)fullName
{
    if (self.byname.length > 0) {
        return [NSString stringWithFormat:@"%@ %@", self.name, self.byname];
    }
    else {
        return self.name;
    }
}

- (NSString *)description
{
    return _byname.nameDescription;
}

- (void)getNewByname:(NSString *)key
{
    
}

@end
