//
//  Character.h
//  LordGame
//
//  Created by MAXIM KORNEEV on 24.01.15.
//  Copyright (c) 2015 AppBit. All rights reserved.
//

#import <SpriteKit/SpriteKit.h>
#import "BaseUnit.h"
#import "Treasury.h"

typedef NS_ENUM(Byte, CharacterType) {
    CharacterKnight,
    CharacterMonk,
    CharacterMage,
    CharacterJester
};

@interface Character : BaseUnit

- (instancetype) initWithType: (CharacterType) type;
- (void)upgradeLevel;
- (void) wink;

@property (assign, nonatomic, readonly) CharacterType type;
@property (assign, nonatomic) BOOL isBusy;
@property (assign, nonatomic) NSInteger specialization;

@property (assign, nonatomic, readonly) Money salary;
@property (assign, nonatomic, readonly) Money goodActionCost;
@property (assign, nonatomic, readonly) Money badActionCost;

@end
