//
//  City.m
//  LordGame
//
//  Created by Michael Dyachenko on 24/01/15.
//  Copyright (c) 2015 AppBit. All rights reserved.
//

#import "City.h"
/*
 1 level - < 5k
 2 level - 5k - 15k
 3 level - 15k >
 */
@implementation City
{
    int _level;
}
- (instancetype) initWithName: (NSString *) name
{
    
    if((self = [super initWithImageNamed:[City getTextureNameForLevel:0]] ))
   {
       _name = name;
       _emotion = (-70.0 + arc4random()%170)/100.0;
       _population = 1000 + arc4random()%19000;
       [self checkCityLevel];
       
   }
    return self;
}

- (NSString *) name
{
    return _name;
}

- (Money) income
{
    if(_emotion < -0.9)
        return 0;
    
    return _population * (1.0 + _emotion);
}

- (void) checkCityLevel{
    int newLevel = 0;
    if(_population < 5000)
    {
        newLevel = 0;
    }
    else if(_population >= 5000 && _population <= 15000)
    {
        newLevel = 1;
    }
    else if(_population > 15000)
    {
        newLevel = 2;
    }

    if(_level != newLevel && (newLevel == 0 || newLevel == 1 || newLevel == 2))
    {
        _level = newLevel;
        self.texture = [SKTexture textureWithImageNamed: [City getTextureNameForLevel:_level]];
    }
    
}

- (void) updatePopulation
{
    _population += (_emotion + 0.5) * 100;
    [self checkCityLevel];
}

- (void) scalePopulation: (float) ratio
{
    _population += _population * ratio;
    [self checkCityLevel];
}

- (void) changeEmotion:(float)ratio
{
    _emotion += ratio;
}

- (void) removeSign
{
    
}
//CITY TEXTURE
+ (NSString *) getTextureNameForLevel: (int) level
{
    NSArray *textureNameList = [NSArray arrayWithObjects: @"city1.png", @"city2.png", @"city3.png",nil];
    if(level >= textureNameList.count)
        return nil;
    
    return textureNameList[level];
}
@end
