//
//  CityNode.m
//  LordGame
//
//  Created by Michael Dyachenko on 24/01/15.
//  Copyright (c) 2015 AppBit. All rights reserved.
//

#import "CityNode.h"
#import "Emotion.h"
static NSString *const FONT_NAME = @"Pixel Cyr";
static NSArray *emotionTypeList;
@implementation CityNode
{

    City *_city;
    NSMutableArray *_emotionList;
}
- (instancetype) initWithCity: (City *) city
{
    if(( self = [super init] ))
    {
        _emotionList = [NSMutableArray new];
        _city = city;
        [self addChild:_city];
        
        
        SKLabelNode* cityName = [SKLabelNode new];
        cityName.text = city.name;
        cityName.fontSize = 25;
        cityName.position = CGPointMake(city.position.x , city.position.y - city.size.height * 0.75);
        cityName.fontColor = [UIColor whiteColor];
        cityName.fontName = FONT_NAME;
        [self addChild:cityName];
        
        for(int i = 0; i < 3; i++) {
            Emotion *emotion = [[Emotion alloc] initWithType:NeutralEmotion];
            [_emotionList addObject:emotion];
            emotion.position = CGPointMake(city.position.x + (i-1)*(emotion.size.width*1.2) , city.position.y - city.size.height * 1.1);
            [self addChild:emotion];
        }
        
        [self updateEmotions];
    }
    
    return self;
}

- (void) updateEmotions
{
    if(emotionTypeList == nil)
    {
        emotionTypeList = @[@(0), @(0), @(0), @(1), @(1), @(1), @(2), @(2), @(2)];
    }
    
    int emotion = _city.emotion * 100;
    int positionEmotion = (emotion + 100)/29;
    
    for(int i = 0; i < 3; i++)
    {
        Emotion *emotion = _emotionList[i];
        EmotionType type = (EmotionType)[emotionTypeList[positionEmotion + i] intValue];
        [emotion setType:type];
    }
    
}
@end
