//
//  EventManager.h
//  LordGame
//
//  Created by MAXIM KORNEEV on 24.01.15.
//  Copyright (c) 2015 AppBit. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "Character.h"

@interface EventManager : NSObject

+ (instancetype)sharedManager;

- (void)chooseEvent;
- (NSString*)message;
- (NSString*)emptyActionName;
- (NSString*)goodActionName;
- (NSString*)badActionName;

- (void)makeEmptyAction;
- (void)makeGoodActionForCharacter:(Character*)character;
- (void)makeBadActionForCharacter:(Character*)character;

- (NSString*)eventResultText;
- (NSArray*)goodResultList;
- (NSArray*)badResultList;

@property (assign, nonatomic, readonly) BOOL eventComplete;

@end
