//
//  GameViewController.m
//  LordGame
//
//  Created by Michael Dyachenko on 24/01/15.
//  Copyright (c) 2015 AppBit. All rights reserved.
//

#import "GameViewController.h"
#import "ThroneScene.h"
#import "NameManager.h"

@implementation GameViewController
{
    IBOutlet UIView* splash;
}

- (void)viewDidLoad
{
    [super viewDidLoad];

    // Configure the view.
    SKView * skView = (SKView *)self.view;
    skView.showsFPS = NO;
    skView.showsNodeCount = NO;
    /* Sprite Kit applies additional optimizations to improve rendering performance */
    skView.ignoresSiblingOrder = YES;
    
    [self performSelector:@selector(getName) withObject:nil afterDelay:0.5];
}

- (void)getName
{
    __block UITextField* alertField = nil;
   // NSString *string = @"Enter King name, please";
    NSString *string = @"Как вас зовут,\n мой Король?";
    UIAlertController* alert = [UIAlertController alertControllerWithTitle:string message:nil preferredStyle:UIAlertControllerStyleAlert];
    [alert addTextFieldWithConfigurationHandler:^(UITextField* textField) {
        alertField = textField;
    }];
    
    UIAlertAction* okAction = [UIAlertAction actionWithTitle:@"OK" style:UIAlertActionStyleDefault handler:^(UIAlertAction *action) {
        [NameManager sharedManager].kingName = alertField.text;
        
        [splash removeFromSuperview];
        
        SKScene *scene = [ThroneScene sharedScene];
        scene.scaleMode = SKSceneScaleModeAspectFill;
        
        SKView * skView = (SKView *)self.view;
        [skView presentScene:scene];
    }];
    
    [alert addAction:okAction];
    
    [self presentViewController:alert animated:YES completion:nil];
}

- (BOOL)shouldAutorotate
{
    return YES;
}

- (NSUInteger)supportedInterfaceOrientations
{
    if ([[UIDevice currentDevice] userInterfaceIdiom] == UIUserInterfaceIdiomPhone) {
        return UIInterfaceOrientationMaskAllButUpsideDown;
    } else {
        return UIInterfaceOrientationMaskAll;
    }
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Release any cached data, images, etc that aren't in use.
}

- (BOOL)prefersStatusBarHidden {
    return YES;
}

@end
