//
//  HireNode.m
//  LordGame
//
//  Created by MAXIM KORNEEV on 25.01.15.
//  Copyright (c) 2015 AppBit. All rights reserved.
//

#import "HireNode.h"
#import "CharacterManager.h"

@implementation HireNode
{
    SKSpriteNode* _hireKnightSprite;
    SKSpriteNode* _hireMonkSprite;
    SKSpriteNode* _hireJesterSprite;
    SKSpriteNode* _hireMageSprite;
}

- (instancetype)init
{
    self = [super init];
    
    if (self != nil) {
        self.userInteractionEnabled = YES;
        
        CGSize deviceSize = [UIScreen mainScreen].bounds.size;
        
        _hireKnightSprite = [SKSpriteNode new];
        _hireKnightSprite.position = CGPointMake(-0.3 * deviceSize.width, 0);
        [self addChild:_hireKnightSprite];
        
        _hireMonkSprite = [SKSpriteNode new];
        _hireMonkSprite.position = CGPointMake(-0.1 * deviceSize.width, 0);
        [self addChild:_hireMonkSprite];
        
        _hireJesterSprite = [SKSpriteNode new];
        _hireJesterSprite.position = CGPointMake(0.1 * deviceSize.width, 0);
        [self addChild:_hireJesterSprite];
        
        _hireMageSprite = [SKSpriteNode new];
        _hireMageSprite.position = CGPointMake(0.3 * deviceSize.width, 0);
        [self addChild:_hireMageSprite];
    }
    
    return self;
}

- (void)update
{
    if ([CharacterManager sharedManager].canHire) {
        
    }
}

- (void)touchesEnded:(NSSet *)touches withEvent:(UIEvent *)event
{
    if ([CharacterManager sharedManager].canHire) {
        UITouch* touch = touches.anyObject;
        CGPoint touchPoint = [touch locationInNode:self];
        
        if (CGRectContainsPoint(_hireKnightSprite.frame, touchPoint)) {
            [[CharacterManager sharedManager] hireCharacter:CharacterKnight];
        }
        else if (CGRectContainsPoint(_hireJesterSprite.frame, touchPoint)) {
            [[CharacterManager sharedManager] hireCharacter:CharacterJester];
        }
        else if (CGRectContainsPoint(_hireMonkSprite.frame, touchPoint)) {
            [[CharacterManager sharedManager] hireCharacter:CharacterMonk];
        }
        else if (CGRectContainsPoint(_hireMageSprite.frame, touchPoint)) {
            [[CharacterManager sharedManager] hireCharacter:CharacterMage];
        }
        
        [self update];
    }
}

@end
