//
//  Reaction.m
//  LordGame
//
//  Created by MAXIM KORNEEV on 24.01.15.
//  Copyright (c) 2015 AppBit. All rights reserved.
//

#import "Reaction.h"
#import "CityManager.h"

static NSString* const ReactionTextKey = @"Text";
static NSString* const ResultListKey = @"Result list";

@implementation Reaction
{
    NSDictionary* _resultsData;
}

- (instancetype)initWithData:(NSDictionary *)reactionData
{
    self = [super init];
    
    if (self != nil) {
        NSString* cityName = [CityManager shared].eventCity.name;
        
        _text = reactionData[ReactionTextKey];
        _text = [_text stringByReplacingOccurrencesOfString:@"<City>" withString:cityName];
        
        _resultsData = reactionData[ResultListKey];
    }
    
    return self;
}

- (Result*)result
{
    Result* goodResult = [[Result alloc] initWithData:_resultsData[@"Good"]];
    goodResult.type = 1;
    
    Result* zeroResult = [[Result alloc] initWithData:_resultsData[@"Zero"]];
    zeroResult.type = 0;
    
    Result* badResult = [[Result alloc] initWithData:_resultsData[@"Bad"]];
    badResult.type = -1;
    
    float sumChance = goodResult.chance + zeroResult.chance + badResult.chance;
    float random = sumChance * (float)(arc4random() % UINT32_MAX) / UINT32_MAX;
    if (random < goodResult.chance) {
        return goodResult;
    }
    else if (random < goodResult.chance + zeroResult.chance) {
        return zeroResult;
    }
    else {
        return badResult;
    }
}

@end
