//
//  Treasury.m
//  LordGame
//
//  Created by MAXIM KORNEEV on 24.01.15.
//  Copyright (c) 2015 AppBit. All rights reserved.
//

#import "Treasury.h"
#import "CityManager.h"
#import "CharacterManager.h"
#import "DSMultilineLabelNode.h"

static const Money START_MONEY = 20000;
@implementation Treasury
{
    DSMultilineLabelNode* _goldLabel;
    SKSpriteNode* _goldIcon;
}

+ (instancetype)sharedTreasury
{
    static Treasury* instance = nil;
    static dispatch_once_t token = 0;
    dispatch_once(&token, ^{
        instance = [Treasury new];
    });
    
    return instance;
}

- (instancetype) init
{
    if(( self = [super init] )) {
        _goldNode = [SKNode new];
        
        _goldIcon = [SKSpriteNode spriteNodeWithImageNamed:@"coin"];
        [_goldNode addChild: _goldIcon];
        
        _goldLabel = [DSMultilineLabelNode new];
        [_goldNode addChild: _goldLabel];
        
        self.gold = START_MONEY;
    }
    
    return self;
    
}
- (Money) income
{
    return [CityManager shared].incomeForAllCities;
}

- (Money) salary
{
    return [CharacterManager sharedManager].salaryForAllCharacters;
}

- (void) receiveIncome
{
    self.gold += [self income];
}

- (void) paySalary
{
    self.gold -= [self salary];
}

- (void)setGold:(Money)gold
{
    _gold = gold;
    [self update];
}

- (void)update
{
    _goldLabel.text = [NSString stringWithFormat:@"%ld", _gold];
    _goldLabel.position = CGPointMake(0.5 * _goldIcon.size.width + 8, 2);
    
    _goldIcon.position = CGPointMake(-0.5 * _goldLabel.size.width - 8, 0);
}

@end
